r"""
Generate the cmpc code and copy it
into the muaompc directory. 
If the file muaompc/muaompc.ino does not exist,
copy a sample file. An existing muaompc/muaompc.ino will not
be replaced.
"""
import shutil

import muaompc

mpc = muaompc.ltidt.setup_mpc_problem('sys_legomotor')
mpc.generate_c_files(numeric='float32', singledir=True)

try:
    shutil.os.mkdir('muaompc')
except FileExistsError:
    pass
else:
    shutil.copy('tmpl_muaompc.ino', shutil.os.path.join('muaompc', 'muaompc.ino'))

for file in shutil.os.listdir('cmpc'):
    fname = shutil.os.path.join('cmpc', file)
    shutil.copy(fname, 'muaompc')
