extern "C" {
#include "mpc.h"
}

extern struct mpc_ctl ctl;
real_t x[MPC_STATES];  /* current state of the system */
unsigned long t1_cpu;
unsigned long dt_cpu;

void setup() {
    Serial.begin(9600);
    const float32_t X0 = 2., X1 = 14.;  /* initial state */
    x[0] = X0;
    x[1] = X1;
    /* muaompc configuration */
    ctl.conf->in_iter = 10;
    ctl.conf->warmstart = 10;
}

void loop() {
    t1_cpu = micros();
    /* Solve MPC problem and print the first element of input sequence */
    mpc_ctl_solve_problem(&ctl, x);  /* solve the MPC problem */
    dt_cpu = micros()-t1_cpu;
    Serial.print("u[0] = "); Serial.print(ctl.u_opt[0]); Serial.println();
    Serial.print("computation time in microseconds = "); Serial.print(dt_cpu); Serial.println();
    delay(1000);  /* Do not print too much */
}
